/*
 * Copyright (C) 2000-2001  Ken McCrary
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Email: jkmccrary@yahoo.com
 */

package estella.util;
import  estella.util.Log;

import java.io.DataOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.net.InetAddress;
import java.net.UnknownHostException;


/**
 *  Classe para gerar um numero que identifica um descritor
 *  DID = Identificacao do Descritor (Descriptor Identification)
 *	Essa classe pertence originalmente ao software jTella versao 0.7 - autor: Ken McCrary - cedida sobre GPL - com modificacoes por Cesar Kallas
 */
public class DID
{
  private static short[] clientID = null;
  private static long bootTime;
  private static long counter = 0x00000000;
  private Log LOG;
	
	/**
	* Instancia uma nova classe do tipo DID
	* @author Cesar Kallas
	*/
	public DID()
	{
		LOG = new Log();
		bootTime = System.currentTimeMillis();
	}
	
	/**
	*  Generate something remotely resembling a windows guid
	* @author KenMcCrary
	*/
  public static short[] gerar()
  {
    // TODO clean this up
    short[] data = new short[16];
    int arrayIndex = 15;
    for (int i = 0; i < 8; i++)
    {
       // Mask to process one byte at a time
       long mask = 0X00000000000000FF;

       // Adjust the mask to look at the appropriate byte
       mask = mask << (8 * i);

       long result = bootTime & mask;

       // Move the byte we interested in to the low order
       result = result >> (8 * i );

       // copy the processed byte
       data[arrayIndex--] = (short)result;
    }

    counter++;
    arrayIndex = 7;
    for (int i = 0; i < 8; i++)
    {
      long mask = 0X00000000000000FF;
      mask = mask << (8 * i);
      long result = counter & mask;

      result = result >> (8 * i );
      data[arrayIndex--] = (short)result;
    }
    return data;
  }
}
